# affinidi_tdk_credential_verification_client

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

For more information, please visit [https://github.com/affinidi/affinidi-tdk](https://github.com/affinidi/affinidi-tdk)

Documentation is available at [https://docs.affinidi.com/dev-tools/affinidi-tdk/clients/credential-verification](https://docs.affinidi.com/dev-tools/affinidi-tdk/clients/credential-verification)

## Requirements.

Python 3.7+

## Installation & Usage

### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install affinidi_tdk_credential_verification_client
```

Then import the package:

```python
import affinidi_tdk_credential_verification_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```

Then import the package:

```python
import affinidi_tdk_credential_verification_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import affinidi_tdk_credential_verification_client
from affinidi_tdk_credential_verification_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://apse1.api.affinidi.io/ver
# See configuration.py for a list of all supported configuration parameters.
configuration = affinidi_tdk_credential_verification_client.Configuration(
    host = "https://apse1.api.affinidi.io/ver"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ProjectTokenAuth
configuration.api_key['ProjectTokenAuth'] = os.environ["API_KEY"]

# Configure a hook to auto-refresh API key for your personal access token (PAT), if expired
import affinidi_tdk_auth_provider

stats = {
  apiGatewayUrl,
  keyId,
  passphrase,
  privateKey,
  projectId,
  tokenEndpoint,
  tokenId,
}
authProvider = affinidi_tdk_auth_provider.AuthProvider(stats)
configuration.refresh_api_key_hook = lambda api_client: authProvider.fetch_project_scoped_token()

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ProjectTokenAuth'] = 'Bearer'


# Enter a context with an instance of the API client
with affinidi_tdk_credential_verification_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = affinidi_tdk_credential_verification_client.DefaultApi(api_client)
    verify_credential_input = affinidi_tdk_credential_verification_client.VerifyCredentialInput() # VerifyCredentialInput | VerifyCredentials

    try:
        # Verifying VC
        api_response = api_instance.verify_credentials(verify_credential_input)
        print("The response of DefaultApi->verify_credentials:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->verify_credentials: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://apse1.api.affinidi.io/ver*

| Class        | Method                                                            | HTTP request                     | Description  |
| ------------ | ----------------------------------------------------------------- | -------------------------------- | ------------ |
| _DefaultApi_ | [**verify_credentials**](docs/DefaultApi.md#verify_credentials)   | **POST** /v1/verifier/verify-vcs | Verifying VC |
| _DefaultApi_ | [**verify_presentation**](docs/DefaultApi.md#verify_presentation) | **POST** /v1/verifier/verify-vp  | Verifying VP |

## Documentation For Models

- [Constraints](docs/Constraints.md)
- [ConstraintsStatuses](docs/ConstraintsStatuses.md)
- [CredentialRequirements](docs/CredentialRequirements.md)
- [CredentialRequirementsConstraints](docs/CredentialRequirementsConstraints.md)
- [Descriptor](docs/Descriptor.md)
- [Error](docs/Error.md)
- [ErrorDetail](docs/ErrorDetail.md)
- [EvaluateVpOutput](docs/EvaluateVpOutput.md)
- [Field](docs/Field.md)
- [Filter](docs/Filter.md)
- [FilterConst](docs/FilterConst.md)
- [FilterItems](docs/FilterItems.md)
- [Format](docs/Format.md)
- [FreeFormObject](docs/FreeFormObject.md)
- [HolderSubject](docs/HolderSubject.md)
- [InputDescriptor](docs/InputDescriptor.md)
- [InvalidParameterError](docs/InvalidParameterError.md)
- [JwtObject](docs/JwtObject.md)
- [LdpObject](docs/LdpObject.md)
- [NestedDescriptor](docs/NestedDescriptor.md)
- [NotFoundError](docs/NotFoundError.md)
- [NotFoundErrorDetailsInner](docs/NotFoundErrorDetailsInner.md)
- [PdStatus](docs/PdStatus.md)
- [PresentationDefinition](docs/PresentationDefinition.md)
- [PresentationSubmission](docs/PresentationSubmission.md)
- [SubmissionRequirement](docs/SubmissionRequirement.md)
- [ValidateJwtInput](docs/ValidateJwtInput.md)
- [ValidateJwtOutput](docs/ValidateJwtOutput.md)
- [VerifyCredentialInput](docs/VerifyCredentialInput.md)
- [VerifyCredentialOutput](docs/VerifyCredentialOutput.md)
- [VerifyPresentationInput](docs/VerifyPresentationInput.md)
- [VerifyPresentationOutput](docs/VerifyPresentationOutput.md)
- [VerifyPresentationOutputErrors](docs/VerifyPresentationOutputErrors.md)
- [W3cCredential](docs/W3cCredential.md)
- [W3cCredentialCredentialSchema](docs/W3cCredentialCredentialSchema.md)
- [W3cCredentialCredentialSubject](docs/W3cCredentialCredentialSubject.md)
- [W3cCredentialHolder](docs/W3cCredentialHolder.md)
- [W3cCredentialStatus](docs/W3cCredentialStatus.md)
- [W3cPresentation](docs/W3cPresentation.md)
- [W3cPresentationContext](docs/W3cPresentationContext.md)
- [W3cPresentationContextOneOfInner](docs/W3cPresentationContextOneOfInner.md)
- [W3cProof](docs/W3cProof.md)

<a id="documentation-for-authorization"></a>

## Documentation For Authorization

Authentication schemes defined for the API:
<a id="UserTokenAuth"></a>

### UserTokenAuth

- **Type**: API key
- **API key parameter name**: authorization
- **Location**: HTTP header

<a id="ProjectTokenAuth"></a>

### ProjectTokenAuth

- **Type**: API key
- **API key parameter name**: authorization
- **Location**: HTTP header

## Author

info@affinidi.com
